#ifndef GLOBAL_H
#define GLOBAL_H

// common C headers
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <ctime>
#include <cmath>

// common STL headers
#include <iostream>
#include <sstream>
#include <fstream>
#include <string>
#include <vector>
#include <list>
#include <deque>
#include <map>
#include <algorithm>
#include <exception>
#include <memory>
#include <type_traits>
#include <functional>
#include <regex>

// string algorithms
#include <boost/algorithm/string.hpp>

// constants
#include <const.h>

// easy types
#include <util/types.h>

// custom types
#include <util/point.h>
#include <util/color.h>
#include <util/rect.h>
#include <util/size.h>

// additional utilities
#include <util/convert.h>
#include <util/foreach.h>
#include <util/makestring.h>
#include <util/logger.h>
#include <util/algorithms.h>

#endif // GLOBAL_H
